#!/bin/bash

module="dedup"

if [ $# -ne 5 ]
then
	echo "Usage $0 <filter_port[0 means all traffic]> <mirror-name> \
		<local-name> <no-iface> <cores>"
	exit 1
fi

local_ip=`host -t A $3 | grep address | awk '{ print $4 }'`
if [ -z ${local_ip} ]; then
	echo "Unable to resolve hostname $3"
	exit 1
fi
mirror_ip=`host -t A $2 | grep address | awk '{ print $4 }'`
if [ -z ${mirror_ip} ]; then
	echo "Unable to resolve hostname $3"
	exit 1
fi

pipe_iface=`ip route get ${mirror_ip} | grep ${mirror_ip} | awk '{ print $5; }'`
echo "Pipe interface is ${pipe_iface}, mirror $2:${mirror_ip}"
sudo insmod ./"${module}".ko filter_port=$1 pipe_iface=${pipe_iface} \
	mirror_ip=${mirror_ip} local_ip=${local_ip} no_iface=$4 cores=$5
