#!/bin/bash

module="maelstrom"

if [ $# -ne 4 ]
then
	echo "Usage $0 <filter_port[0 means all traffic]> <mirror-name> \
		<local-name> <cores>"
	exit 1
fi

local_ip=`host -t A $3 | grep address | awk '{ print $4 }'`
if [ -z ${local_ip} ]; then
	echo "Unable to resolve hostname $3, falling back on gethostbyname"
	local_ip=`python -c "import socket;print(socket.gethostbyname('$3'))"`
fi
mirror_ip=`host -t A $2 | grep address | awk '{ print $4 }'`
if [ -z ${mirror_ip} ]; then
	echo "Unable to resolve hostname $2, falling back on gethostbyname"
	mirror_ip=`python -c "import socket;print(socket.gethostbyname('$2'))"`
fi

ip_route_response=`ip route get ${mirror_ip} | grep ${mirror_ip}`
pipe_iface=`python -c "x='${ip_route_response}';print(x.split()[-3])"`
echo "Pipe interface is ${pipe_iface}, mirror $2:${mirror_ip}"
sudo insmod ./"${module}".ko filter_port=$1 pipe_iface=${pipe_iface} \
	mirror_ip=${mirror_ip} local_ip=${local_ip} cores=$4
